<?php
uses('sanitize');

class FtpsController extends AppController {

	var $name = 'Ftps';
        var $uses = array('Ftp', 'Ftp_file');
	var $helpers = array('Html', 'Form' );

        function beforeFilter() {
                $groupid = $this->Session->read('group');
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                if (!$groupid || !$polid || !$solid) {
                    $this->redirect('/users/login');
                }
        }

	function index() {
                $solid = $this->Session->read('sol');
                $this->Ftp->recursive = -1;
                if ($this->data) {
                    $srch = $this->data['Search']['label'];
                    $this->set('ftps', $this->Ftp->findAll("sol_id = $solid AND (url LIKE '%$srch%' OR username LIKE '%$srch%')", NULL, 'Ftp.capture_date DESC'));
                }
                else {
                    $this->set('ftps', $this->Ftp->findAll("sol_id = $solid", NULL, 'Ftp.capture_date DESC'));
                }
                $this->set('menu_left', array( array('label' => 'Sols', 'link' => '/sols/index'),
                                               array('label' => '', 'link' => ''),
                                               array('label' => 'Email', 'link' => '/emails/index'),
                                               array('label' => 'Sip', 'link' => '/sips/index'),
                                               array('label' => 'Web', 'link' => '/webs/index'),
                                               array('label' => 'Images', 'link' => '/webs/image'),
                                               array('label' => 'Printer', 'link' => '/pjls/index'),
                                               array('label' => 'Ftp', 'link' => '/ftps/index'),
                                               array('label' => 'Mms', 'link' => '/mms/index'),
                                               array('label' => 'GeoMap', 'link' => '/inputs/geomap'),
                               ));
	}

	function view($id = null) {
		if (!$id) {
                    exit();
		}
                $this->set('menu_left', array( array('label' => 'Sols', 'link' => '/sols/index'),
                                               array('label' => '', 'link' => ''),
                                               array('label' => 'Email', 'link' => '/emails/index'),
                                               array('label' => 'Sip', 'link' => '/sips/index'),
                                               array('label' => 'Web', 'link' => '/webs/index'),
                                               array('label' => 'Images', 'link' => '/webs/image'),
                                               array('label' => 'Printer', 'link' => '/pjls/index'),
                                               array('label' => 'Ftp', 'link' => '/ftps/index'),
                                               array('label' => 'Mms', 'link' => '/mms/index'),
                                               array('label' => 'GeoMap', 'link' => '/inputs/geomap'),
                               ));
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                $this->Ftp->recursive = -1;
                $ftp = $this->Ftp->read(null, $id);
                if ($polid != $ftp['Ftp']['pol_id'] || $solid != $ftp['Ftp']['sol_id']) {
                    $this->redirect('/users/login');
                }
                //print_r($ftp);
                $this->Session->write('ftpid', $id);
		$this->set('ftp', $ftp);

                /* files */
                $this->Ftp_file->recursive = -1;
                //$this->set('ftp_file', $this->Ftp_file->findAll("sol_id = $solid AND ftp_id = $id AND file_size != 0", NULL, 'Ftp_file.capture_date DESC'));
                $this->set('ftp_file', $this->Ftp_file->findAll("sol_id = $solid AND ftp_id = $id", NULL, 'Ftp_file.capture_date DESC'));
                // register visualization
                if (!$ftp['Ftp']['first_visualization_user_id']) {
                    $uid = $this->Session->read('userid');
                    $ftp['Ftp']['first_visualization_user_id'] = $uid;
                    $ftp['Ftp']['viewed_date'] = date("Y-m-d H:i:s");
                    $this->Ftp->save($ftp);
                }
	}

        function cmd() {
            $id = $this->Session->read('ftpid');
            if (!$id) {
                $this->redirect('/users/login');
            }
            else {
                $ftp = $this->Ftp->read(null, $id);
                header("Content-Disposition: filename=ftp_cmd".$id.".txt");
                header("Content-Type: text");
                header("Content-Length: " . filesize($ftp['Ftp']['cmd_path']));
                readfile($ftp['Ftp']['cmd_path']);
                exit();
            }
        }

        function info() {
            $id = $this->Session->read('ftpid');
            if (!$id) {
                $this->redirect('/users/login');
            }
            else {
                $this->Ftp->recursive = -1;
                $ftp = $this->Ftp->read(null, $id);
                header("Content-Disposition: filename=info".$id.".xml");
                header("Content-Type: application/xhtml+xml; charset=utf-8");
                header("Content-Length: " . filesize($ftp['Ftp']['flow_info']));
                readfile($ftp['Ftp']['flow_info']);
                exit();
            }
        }

        function info_data($id_data = null) {
            $id = $this->Session->read('ftpid');
            if (!$id || !$id_data) {
                $this->redirect('/users/login');
            }
            else {
                $this->Ftp_file->recursive = -1;
                $ftp_file = $this->Ftp_file->read(null, $id_data);
                header("Content-Disposition: filename=info_data".$id_data.".xml");
                header("Content-Type: application/xhtml+xml; charset=utf-8");
                header("Content-Length: " . filesize($ftp_file['Ftp_file']['flow_info']));
                readfile($ftp_file['Ftp_file']['flow_info']);
                exit();
            }
        }

        function data_file($id_data = null) {
            $id = $this->Session->read('ftpid');
            if (!$id || !$id_data) {
                $this->redirect('/users/login');
            }
            else {
                $this->Ftp_file->recursive = -1;
                $ftp_data = $this->Ftp_file->read(null, $id_data);
                header("Content-Disposition: filename=" . $ftp_data['Ftp_file']['filename']);
                header("Content-Type: bin");
                header("Content-Length: " . filesize($ftp_data['Ftp_file']['file_path']));
                readfile($ftp_data['Ftp_file']['file_path']);
                //print_r($ftp_data);
                exit();
            }
        }
}
?>
